<?php

# ******************************
# General Information Section
# ******************************
$directory = "/tmp/pooch/";

# ******************************
# Get POST variables
# ******************************
$keys = array_keys($HTTP_POST_VARS);
$numberofkeys = count($keys);
$node_array = array();
$file_array = array();
$nodelisting = "<table>";
$filelisting = "<table>";
$runcommand = "";


# **********************************
# Determine nodes and files selected
# **********************************
for ($count = 0; $count<$numberofkeys; $count++) {
$fromarray = $keys[$count];
$nodecount = strpos($keys[$count], 'node');
if ($nodecount <> false)
{array_push($node_array, $HTTP_POST_VARS[$fromarray]);
}
$filecount = strpos($keys[$count], 'file');
if ($filecount <> false)
{array_push($file_array, $HTTP_POST_VARS[$fromarray]);
}
}

# ********************************************************
# Create Node and File Arrays along with final run command
# ********************************************************
$numberofnodes = count($node_array);
$numberoffiles = count($file_array);

for ($count = 0; $count<$numberoffiles; $count++) {
$filedecode = urldecode($file_array[$count]);
$temp = "<tr><td>$filedecode</td></tr>";
$filelisting = $filelisting.$temp;
$runcommand = $runcommand." ".$directory.$filedecode;

}
$filelisting = $filelisting."</table>";

$runcommand = $runcommand." "."-n";

for ($count = 0; $count<$numberofnodes; $count++) {
$temp = "<tr><td>$node_array[$count]</td></tr>";
$nodelisting = $nodelisting.$temp;
$runcommand = $runcommand." ".$node_array[$count];
}
$nodelisting = $nodelisting."</table>";

$runcommand = urlencode($runcommand);

# ******************************
# Diagnostic Section
# ******************************
#$test = urldecode($runcommand);
#var_dump($test);
#var_dump($HTTP_POST_VARS);
?>


<html>
<head>
  <title>Pooch HTML Interface</title>
                                          
  <meta http-equiv="content-type"
 content="text/html; charset=ISO-8859-1">
</head>
 <body>
		<table align="center" bgcolor="#999999" width="600" border="0"
 cellspacing="0" cellpadding="0">
 <tbody>
    <tr>
      <td align="center" width="600" height="300" valign="middle">  
      <table cellpadding="2" cellspacing="2" border="0" width="95%">
   <tbody>
<tr>
 <td valign="top" rowspan="1" colspan="2" align="center"><b><font size="+1">Pooch  Job Window<br></font></b></td>
 </tr>
								<tr>
									<td valign="top" align="center"></td>
									<td valign="top" align="center"></td>
								</tr>
								<tr>
									<td valign="top" width=50% bgcolor="#c0c0c0" align="center"><b>Selected Files</b></td>
									<td valign="top" width=50% bgcolor="#c0c0c0" align="center"><b>Selected Nodes</b></td>
								</tr>
								<tr>
  <td valign="top" height="100" bgcolor="#ffffff" rowspan="1" colspan="2"><div style="width:100%;height:100%;overflow:auto;">
  <table width=100%><tr><td width=50% valign=top><?php print $filelisting ?></td><td width=50% valign=top><?php print $nodelisting ?></td></tr>
  </table>
</div></td>
 </tr>
 <tr>
									<FORM ACTION="job-interface.php" METHOD="post">
 <td colspan="2" valign="top">
											<div align="center">
												<INPUT TYPE="submit" NAME="returntointerface" VALUE="Return to Job Window"></div>
										</td></FORM>
								</tr>
 <FORM ACTION="job-submit.php" METHOD="post"><INPUT TYPE="hidden" NAME="run_command" VALUE="<?php print $runcommand ?>">
 <tr>
 <td valign="top" rowspan="1" colspan="2" bgcolor="#c0c0c0">Job Options<br>
            </td>
 </tr>
 <tr>
 <td valign="top" rowspan="1" colspan="2" bgcolor="#ffffff" height="287">
											<table cellpadding="2" cellspacing="2" border="1" width="100%">
 <tbody>
                 <tr>
                   <td valign="top" width="20%" align="center"><input type="checkbox" name="-m"><br>
                   </td>
                   <td valign="top" width="80%">Don't include this node in the node list by default<br>
                   </td>
                 </tr>
                 <tr>
                   <td valign="top" width="20%" align="center"><input type="checkbox" name="-allcpus"><br>
                   </td>
                   <td valign="top" width="80%">Include every cpu and node Pooch can find<br>
                   </td>
                 </tr>
                 <tr>
                   <td valign="top" width="20%" align="center"><input type="text" name="-d" value="" size="10" length="50"><br>
                   </td>
                   <td valign="top" width="80%">Select a directory for the files to be on the remote nodes<br>
                   </td>
                 </tr>
                 <tr>
                   <td valign="top" width="20%" align="center"><input type="checkbox" name="-t"><br>
                   </td>
                   <td valign="top" width="80%">Prints out what mpirun will do, rather than doing it<br>
                   </td>
                 </tr>
                 <tr>
                   <td valign="top" width="20%" align="center">
                  <select name="-T" size="1">
                  <option value="" selected="selected"></option>
                  <option value="MacMPI">MacMPI</option>
                  <option value="mpich">mpich</option>
                  <option value="MPIPro">MPIPro</option>
                  <option value="mpichgm">mpichgm</option>
                  <option value="lam">lam</option>
                  </select>
 				</td>
                   <td valign="top" width="80%">Select an MPI type for the job<br>
                   </td>
                 </tr>
                 <tr>
                   <td valign="top" width="20%" align="center">
                  <select name="-r" size="1">
                  <option value="" selected="selected"></option>
                  <option value="-0">node 0</option>
                  <option value="all">all</option>
                  <option value="off">off</option>
                  </select>
                   </td>
                   <td valign="top" width="80%">Retrieve output<br>
                   </td>
                 </tr>
                 <tr>
                   <td valign="top" width="20%" align="center">
                  <select name="-p" size="1">
                  <option value="" selected="selected"></option>
                  <option value="-0">0</option>
                  <option value="-1">1</option>
                  <option value="-2">2</option>
                  <option value="-4">4</option>
                  <option value="-8">8</option>
                  <option value="-16">16</option>
                  </select>
                   </td>
                   <td valign="top" width="80%">Number of tasks per computer (0 = use proc count)<br>
                   </td>
                 </tr>
                 <tr>
                   <td valign="top" width="20%" align="center"><input type="checkbox" name="-K"><br>
                   </td>
                   <td valign="top" width="80%">Skip the check for nodes being BUSY and launch anyway<br>
                   </td>
                 </tr>
                 <tr>
                   <td valign="top" width="20%" align="center"><input type="checkbox" name="-Q"><br>
                   </td>
                   <td valign="top" width="80%">In case of a launch failure, Pooch queues the job for later relaunch<br>
                   </td>
                 </tr>
               
              </tbody>             
            </table>
										</td>
            </tr>
            <tr>
										<td valign="top"><br>
            </td>
										<td valign="top"><br>
            </td>
          </tr>
          <tr>
              <td valign="top" align="center" rowspan="1" colspan="2"><INPUT TYPE="submit" NAME="launch" VALUE="Launch Job">
              </td></FORM>
  </tr>
                                                                 
        </tbody>                                     
      </table>
	</body>
</html>